(in-package "MORPHICL")

(defclass event ()
  ((port        :type port      :initarg :port      :reader event-port)
   (position    :type point     :initarg :position  :reader event-position)))

(defun eventp (object)
  (typep object 'event))

(defgeneric event-port ((event event)))
(defgeneric event-position ((event event)))

(defclass display-event (event)
  ())

(defun display-event-p (object)
  (typep object 'display-event))

(defclass display-redraw-event (display-event)
  ())

(defclass display-resize-event (display-event)
  ((bounds       :type rectangle :initarg :bounds    :reader display-resize-event-bounds)))

(defgeneric display-resize-event-bounds ((event display-resize-event)))

(defclass keyboard-event (event)
  ())

(defun keyboard-event-p (object)
  (typep object 'keyboard-event))

(defclass key-event (keyboard-event)
  ((key         :type character :initarg :key       :reader key-event-key)))

(defgeneric key-event-key ((event key-event)))

(defclass key-press-event (key-event)
  ())

(defclass key-release-event (key-event)
  ())

(defclass pointer-event (event)
  ())

(defun pointer-event-p (object)
  (typep object 'pointer-event))

(defconstant +pointer-button-left+ 1)
(defconstant +pointer-button-middle+ 2)
(defconstant +pointer-button-right+ 3)

(defclass pointer-motion-event (pointer-event)
  ())
  
(defclass pointer-button-event (pointer-event)
  ((button      :type integer   :initarg :button    :reader pointer-button-event-button)))

(defgeneric pointer-button-event-button ((event pointer-button-event)))

(defclass pointer-button-press-event (pointer-button-event)
  ())

(defclass pointer-button-release-event (pointer-button-event)
  ())

(defclass morph-event (event)
  ((morph       :type morph     :initarg :morph    :reader morph-event-morph)))

(defun morph-event-p (object)
  (typep object 'morph-event))

(defgeneric morph-event-morph ((morph morph-event)))

(defclass morph-drop-event (morph-event)
  ())

