(in-package "MORPHICL")

(defclass alignment-morph (morph)
  ())

(defclass horizontal-alignment-morph (alignment-morph)
  ())

(defmethod morph-add-submorph-at :after ((morph horizontal-alignment-morph) (submorph morph) position)
  (declare (ignore position))
  (loop for submorph in (morph-submorphs morph)
        for offset = 0 then (+ offset (rectangle-width (morph-bounds submorph)))
    do (rectangle-translate
         (morph-bounds submorph)
         (- offset (rectangle-left (morph-bounds submorph)))
         0)))

(defclass vertical-alignment-morph (alignment-morph)
  ())

(defmethod morph-add-submorph-at :after ((morph vertical-alignment-morph) (submorph morph) position)
  (declare (ignore position))
  (loop for submorph in (morph-submorphs morph)
        for offset = 0 then (+ offset (rectangle-height (morph-bounds submorph)))
    do (rectangle-translate
         (morph-bounds submorph)
         0
         (- offset (rectangle-top (morph-bounds submorph))))))

